/*
 * @(#)Ray3D.java    Pzt 10 May 2010 14:32:03 EEST
 *
 * Ray 3d for 3d world
 */
/*
*** This program wrote under GNU/General Public License ***

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.
*/
package net.dilmerkezi.ray;

//custom
import net.dilmerkezi.point.*;


/**
 * @author Murat iNAN, dilmerkezi.net/eng.html
 */
public class Ray3D
     extends Object
  implements Ray
{

    /** Origin point*/
    private Point3D origin;
    
    /** Direction point*/
    private Point3D direction;
    
    /**
     * First constructor
     */
    public Ray3D ()
    {
        this.origin = new Vector3D ();
        this.direction = new Vector3D ();
    }
    
    /**
     * Second constructor
     *
     * @param poi New origin
     * @param doi New direction
     */
    public Ray3D (Point3D poi, Point3D doi)
    {
        this.origin = poi;
        this.direction = doi;
    }
    
    /**
     * @param d The value for using in computacion of at time
     * @return At time 3D point
     */
    public Point3D atTime (double d)
    {
        double c1 = origin.getX ()+(d*direction.getX ());
        double c2 = origin.getY ()+(d*direction.getY ());
        double c3 = origin.getZ ()+(d*direction.getZ ());
        return new Vector3D (c1, c2, c3);
    }

    /** @return Origin 3D point*/
    public Point3D getOriginPoint3D ()
    {
        return origin;
    }
    
    /** @return Direction 3D point*/
    public Point3D getDirectionPoint3D ()
    {
        return direction;
    }
    
    /**
     * @param r Comparation ray
     * @return If equals true, otherwise false;
     */
    public boolean equals (Ray3D r)
    {
        return (getOriginPoint3D ().equals (r.getOriginPoint3D ()) &&
                getDirectionPoint3D ().equals (r.getDirectionPoint3D ()));
    }
    
    /** @return hashcode*/
    public int hashCode ()
    {
        String s = toString ();
        int result = 0;
        char [] ch = s.toCharArray ();
        int chlen = ch.length;
        int ff = 0xff;
        for (int i=0; i<chlen; i++)
        {
            result += ( ((int)(ch [i]))*ff );
        }
        return result;
    }
    
    /** @return Description*/
    public String toString ()
    {
        StringBuffer sb = new StringBuffer ();
        sb.append (getOriginPoint3D ().toString ());
        sb.append ("\n---------\n");
        sb.append (getDirectionPoint3D ().toString ());
        sb.append ("\n");
        return sb.toString ();
    }
    
}
/****************/
